<?php
if (!defined('_VALID_MOS') && !defined('_JEXEC'))
	die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

class ps_payanyway {

	var $classname = "ps_payanyway";	
	var $payment_code = "PAW";
	
	/**
	 * Shows the configuration form for this payment module in the payment method form
	 * 
	 * @param void
	 * @return string
	 */
	function show_configuration() {
		global $VM_LANG;
		$db = new ps_DB();
		$VM_LANG->load('payanyway');
			
		// Read current Configuration
		include_once(CLASSPATH ."payment/ps_payanyway.cfg.php");
				
		?>
<p style="text-align: center;font-weight: bold;"><?php echo $VM_LANG->_('PAYANYWAY_TITLE') ?></p>
<p><?php echo $VM_LANG->_('PAYANYWAY_DESC') ?></p><br>
<table>
	<tr>
		<td><strong><?php echo $VM_LANG->_('PAYANYWAY_TEST_MODE') ?></strong></td>
		<td>
			<select name="MNT_TEST_MODE" class="inputbox" >
				<option <?php if (@MNT_TEST_MODE == '1') echo "selected=\"selected\""; ?> value="1">
					<?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?>
				</option>
				<option <?php if (@MNT_TEST_MODE != '1') echo "selected=\"selected\""; ?> value="0">
					<?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?>
				</option>
			</select>
		</td>
		<td><?php echo $VM_LANG->_('PAYANYWAY_TEST_MODE_DESC') ?></td>
	</tr>

	<tr>
		<td><strong><?php echo $VM_LANG->_('PAYANYWAY_MNT_KASSA') ?></strong></td>
		<td>
			<select name="MNT_KASSA" class="inputbox" >
				<option <?php if (@MNT_KASSA == '1') echo "selected=\"selected\""; ?> value="1">
					<?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?>
				</option>
				<option <?php if (@MNT_KASSA != '1') echo "selected=\"selected\""; ?> value="0">
					<?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?>
				</option>
			</select>
		</td>
		<td><?php echo $VM_LANG->_('PAYANYWAY_PAYMENT_MNT_KASSA_DESC') ?></td>
	</tr>

	<tr>
		<td><strong><?php echo $VM_LANG->_('PAYANYWAY_PAYMENT_SERVER') ?></strong></td>
		<td><input type="text" name="MNT_PAYMENT_SERVER" class="inputbox" value="<?php echo MNT_PAYMENT_SERVER ?>" /></td>
		<td><?php echo $VM_LANG->_('PAYANYWAY_PAYMENT_SERVER_DESC') ?></td>
	</tr>

	<tr>
		<td><strong><?php echo $VM_LANG->_('PAYANYWAY_ID') ?></strong></td>
		<td><input type="text" name="MNT_ID" class="inputbox" value="<?php echo MNT_ID ?>" /></td>
		<td><?php echo $VM_LANG->_('PAYANYWAY_ID_DESC') ?></td>
	</tr>
	
	<tr>
		<td><strong><?php echo $VM_LANG->_('DATA_INTEGRITY_CODE') ?></strong></td>
		<td><input type="text" name="DATA_INTEGRITY_CODE" class="inputbox" value="<?php echo DATA_INTEGRITY_CODE ?>" /></td>
		<td><?php echo $VM_LANG->_('DATA_INTEGRITY_CODE_DESC') ?></td>
	</tr>

	<tr>
		<td><strong><?php echo $VM_LANG->_('PAYANYWAY_LOGIN') ?></strong></td>
		<td><input type="text" name="PAYANYWAY_LOGIN" class="inputbox" value="<?php echo PAYANYWAY_LOGIN ?>" /></td>
		<td><?php echo $VM_LANG->_('PAYANYWAY_LOGIN_DESC') ?></td>
	</tr>
	
	<tr>
		<td><strong><?php echo $VM_LANG->_('PAYANYWAY_PASSWORD') ?></strong></td>
		<td><input type="password" name="PAYANYWAY_PASSWORD" class="inputbox" value="<?php echo PAYANYWAY_PASSWORD ?>" /></td>
		<td><?php echo $VM_LANG->_('PAYANYWAY_PASSWORD_DESC') ?></td>
	</tr>
	
</table>
		<?php
	}

	/**
	 * Returns true if the payment module can be configured, false if not
	 * 
	 * @param void
	 * @return boolean
	 */
	function has_configuration() {
		return true;
	}

	/**
	 * Returns true if the configuration file for that payment module is writeable, false if not
	 * 
	 * @param void
	 * @return boolean
	 */
	function configfile_writeable() {
		return is_writeable(CLASSPATH . "payment/ps_payanyway.cfg.php");
	}

	/**
	 * Returns true if the configuration file for that payment module is readable, false if not
	 * 
	 * @param void
	 * @return boolean
	 */
	function configfile_readable() {
		return is_readable(CLASSPATH . "payment/ps_payanyway.cfg.php");
	}

	/**
	 * Stores all configuration values for this payment module in the configuration file
	 * 
	 * @param array $d An array of objects
	 * @return void
	 */
	function write_configuration(&$d) {
		if (isset($d['MNT_ID']))
		{
			$my_config_array = array(
				"MNT_PAYMENT_SERVER"        => $d['MNT_PAYMENT_SERVER'],
				"MNT_ID" 					=> $d['MNT_ID'],
				"DATA_INTEGRITY_CODE" 		=> $d['DATA_INTEGRITY_CODE'],
				"MNT_TEST_MODE" 			=> $d['MNT_TEST_MODE'],
				"MNT_KASSA"		 			=> $d['MNT_KASSA'],
				"PAYANYWAY_LOGIN"			=> $d['PAYANYWAY_LOGIN'],
				"PAYANYWAY_PASSWORD"		=> $d['PAYANYWAY_PASSWORD']
			);

			$config = "<?php\n";
			$config .= "if(!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to '.basename(__FILE__).' is not allowed.'); \n\n";
			foreach($my_config_array as $key => $value) {
				$config .= "define('$key', '$value');\n";
			}
			$config .= "?>";

			if ($fp = fopen(CLASSPATH ."payment/ps_payanyway.cfg.php", "w")) {
				fputs($fp, $config, strlen($config));
				fclose($fp);
				return true;
			}
			else
				return false;
		}
		else
		{
			return false;
		}
	}

	/**
	 * This is the main function for all payment modules that use direct connections 
	 * to a payment gateway (like authorize.net or eWay XML). 
	 * This is the place, where the payment details are validated and captured on success.
	 * Returns true on sucess, false on failure.
	 * 
	 * @param string $order_number
	 * @param float $order_total
	 * @param array $d An array of objects
	 * @return boolean
	 */
	function process_payment($order_number, $order_total, &$d) {
		 return true;
	}
	
	/**
	 * This is the function to calculate the fee / discount for this special payment module 
	 * (so you can calculate a fee, depending on the order total amount).
	 * 
	 * @param float $subtotal	 
	 * @return float
	 */
	function get_payment_rate($subtotal) {}
}
?>