<?php
if (!defined('_VALID_MOS') && !defined('_JEXEC'))
	die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

include_once(CLASSPATH ."payment/ps_payanyway.php");

class ps_payanyway_euroset extends ps_payanyway {

	var $classname = "ps_payanyway_euroset";	
	var $payment_code = "ES";
	
	/**
	 * Shows the configuration form for this payment module in the payment method form
	 * 
	 * @param void
	 * @return string
	 */

	function show_configuration() {
		parent::show_configuration();
	}

	/**
	 * Returns true if the payment module can be configured, false if not
	 * 
	 * @param void
	 * @return boolean
	 */
	function has_configuration() {
		return true;
	}

	/**
	 * Returns true if the configuration file for that payment module is writeable, false if not
	 * 
	 * @param void
	 * @return boolean
	 */
	function configfile_writeable() {
		return is_writeable(CLASSPATH . "payment/" . $this->classname . ".cfg.php");
	}

	/**
	 * Returns true if the configuration file for that payment module is readable, false if not
	 * 
	 * @param void
	 * @return boolean
	 */
	function configfile_readable() {
		return is_readable(CLASSPATH . "payment/" . $this->classname . ".cfg.php");
	}

	/**
	 * Stores all configuration values for this payment module in the configuration file
	 * 
	 * @param array $d An array of objects
	 * @return void
	 */
	function write_configuration(&$d) {	
		parent::write_configuration($d);
		
		$my_config_array = array(
			"PAYANYWAY_ACTION" => URL."index.php?page=checkout.payanyway_result&option=com_virtuemart&result=invoice",
            "PAYMENTSYSTEM_UNITID" => 248362,
			"PAYMENTSYSTEM_LIMITIDS" => '248362',
			"PAYMENTSYSTEM_ACCOUNTID" => '136'
        );
        
		$config = "<?php\n";
		$config .= "if(!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to '.basename(__FILE__).' is not allowed.'); \n\n";
		foreach($my_config_array as $key => $value) {
			$config .= "define('$key', '$value');\n";
		}
		$config .= "?>";
	  
		if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
			fputs($fp, $config, strlen($config));
			fclose($fp);
			return true;
		}
		else
			return false;
	}

	/**
	 * This is the main function for all payment modules that use direct connections 
	 * to a payment gateway (like authorize.net or eWay XML). 
	 * This is the place, where the payment details are validated and captured on success.
	 * Returns true on sucess, false on failure.
	 * 
	 * @param string $order_number
	 * @param float $order_total
	 * @param array $d An array of objects
	 * @return boolean
	 */
	function process_payment($order_number, $order_total, &$d) {
		 return true;
	}
	
	/**
	 * This is the function to calculate the fee / discount for this special payment module 
	 * (so you can calculate a fee, depending on the order total amount).
	 * 
	 * @param float $subtotal	 
	 * @return float
	 */
	function get_payment_rate($subtotal) {}
}
?>