<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

require_once (CLASSPATH . 'payment/ps_payanyway.cfg.php');

$VM_LANG->load('payanyway');

$result = vmGet( $vars, 'result'  );

debugMsg($_REQUEST);
switch( $result ) {

	case 'invoice':		
		mm_showMyFileName( __FILE__ );

		$payment_method = $_REQUEST['payment_class'];
		require_once (CLASSPATH . 'payment/MonetaAPI/MonetaWebService.php');
        switch (MNT_PAYMENT_SERVER)
        {
            case "demo.moneta.ru":
                $service = new MonetaWebService("https://demo.moneta.ru/services.wsdl", PAYANYWAY_LOGIN, PAYANYWAY_PASSWORD);
                break;
            case "www.payanyway.ru":
                $service = new MonetaWebService("https://www.moneta.ru/services.wsdl", PAYANYWAY_LOGIN, PAYANYWAY_PASSWORD);
                break;
        }
		
        try
        {
            // получить данные счета
            $request = new MonetaInvoiceRequest();
			$request->payer = $_REQUEST['paymentSystem_accountId'];
            $request->payee = $_REQUEST['MNT_ID'];
            $request->amount = $_REQUEST['MNT_AMOUNT'];
            $request->clientTransaction = $_REQUEST['MNT_TRANSACTION_ID'];
			if ($payment_method == 'ps_payanyway_postal')
			{
				$operationInfo = new MonetaOperationInfo();
				$a1 = new MonetaKeyValueAttribute();
				$a1->key = 'mailofrussiaindex';
				$a1->value = $_REQUEST['additionalParameters_mailofrussiaSenderIndex'];
				$operationInfo->addAttribute($a1);
				$a2 = new MonetaKeyValueAttribute();
				$a2->key = 'mailofrussiaaddress';
				$a2->value = $_REQUEST['additionalParameters_mailofrussiaSenderAddress'];
				$operationInfo->addAttribute($a2);
				$a3 = new MonetaKeyValueAttribute();
				$a3->key = 'mailofrussianame';
				$a3->value = $_REQUEST['additionalParameters_mailofrussiaSenderName'];
				$operationInfo->addAttribute($a3);
				$request->operationInfo = $operationInfo;
			}
			elseif ($payment_method == 'ps_payanyway_euroset')
			{
				$operationInfo = new MonetaOperationInfo();
				$a1 = new MonetaKeyValueAttribute();
				$a1->key = 'rapidamphone';
				$a1->value = $_REQUEST['additionalParameters_rapidaPhone'];
				$operationInfo->addAttribute($a1);
				$request->operationInfo = $operationInfo;
			}

            $response = $service->Invoice($request);
			if ($payment_method == 'ps_payanyway_euroset')
			{
				$response1 = $service->GetOperationDetailsById($response->transaction);
				foreach ($response1->operation->attribute as $attr)
				{
					if ($attr->key == 'rapidatid')
					{
						$transaction_id = $attr->value;
					}
				}
			}
			else
			{
				$transaction_id = $response->transaction;
			}
			
			$ps_code = strtoupper(substr($payment_method,13));
			$transaction = str_pad($transaction_id, 10, "0", STR_PAD_LEFT);

			echo '<h2>'.$VM_LANG->_('PAYANYWAY_INVOICE_TITLE_CREATED').'</h2><br /><br />';
			echo vmCommonHTML::imageTag( VM_THEMEURL .'images/button_ok.png', 'Success', 'center', '48', '48' );

			if (!in_array($ps_code, array('POSTAL', 'BANKTRANSFER')))
			{
				echo '<h3>'.$VM_LANG->_('PAYANYWAY_'.$ps_code.'_INVOICE_CREATED_1').' '.$transaction.'</h3>';
				echo '<p>'.$VM_LANG->_('PAYANYWAY_'.$ps_code.'_INVOICE_CREATED_2').'</p>';
				echo '<p>'.$transaction.'</p>';
				echo '<p>'.$VM_LANG->_('PAYANYWAY_'.$ps_code.'_INVOICE_CREATED_3').' '.$_REQUEST['MNT_AMOUNT']." ".$_REQUEST['MNT_CURRENCY_CODE'].'</p>';
			}
			else
			{
				echo '<p>'.str_replace('%transaction%', $transaction, $VM_LANG->_('PAYANYWAY_'.$ps_code.'_INVOICE_CREATED')).'</p>';
			}
        }
        catch (Exception $e)
        {
			echo '<h2>'.$VM_LANG->_('PAYANYWAY_INVOICE_TITLE_ERROR').'<h2><br /><br />';
			echo '<p class="shop_info">'.$e->getMessage().'</p>';
        }
		break;
}

function debugMsg($msg) {	
	// logging
	$fp = fopen('./payanyway.log', 'a+');
	$str = date('Y-m-d H:i:s') . ' - ';

	fwrite($fp, $str . "\n" . print_r($msg, true). "\n\n");
	fclose($fp); 
}

?>