<?php

const paw_kassa_VAT0     = '1104';  // НДС 0%
const paw_kassa_VAT10    = '1103';  // НДС 10%
const paw_kassa_VAT18    = '1102';  // НДС 18%
const paw_kassa_VATNOVAT = '1105';  // НДС не облагается
const paw_kassa_VATWR10  = '1107';  // НДС с рассч. ставкой 10%
const paw_kassa_VATWR18  = '1106';  // НДС с рассч. ставкой 18%

function monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, $success = false,
							  $repeatRequest = false, $echo = true, $die = true, $kassa_inventory = null, $kassa_customer = null, $kassa_delivery = null)
{
	if ($success === true)
		$resultCode = '200';
	elseif ($repeatRequest === true)
		$resultCode = '402';
	else
		$resultCode = '500';
	$mnt_signature = md5($resultCode.$mnt_id.$mnt_transaction_id.$mnt_data_integrity_code);
	$response = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
	$response .= "<MNT_RESPONSE>\n";
	$response .= "<MNT_ID>{$mnt_id}</MNT_ID>\n";
	$response .= "<MNT_TRANSACTION_ID>{$mnt_transaction_id}</MNT_TRANSACTION_ID>\n";
	$response .= "<MNT_RESULT_CODE>{$resultCode}</MNT_RESULT_CODE>\n";
	$response .= "<MNT_SIGNATURE>{$mnt_signature}</MNT_SIGNATURE>\n";
	if (!empty($kassa_inventory) || !empty($kassa_customer) || !empty($kassa_delivery))
	{
		$response .= "<MNT_ATTRIBUTES>\n";
		foreach (array('INVENTORY' => $kassa_inventory, 'CUSTOMER' => $kassa_customer, 'DELIVERY' => $kassa_delivery) as $k => $v)
			if (!empty($v))
				$response .= "<ATTRIBUTE><KEY>{$k}</KEY><VALUE>{$v}</VALUE></ATTRIBUTE>\n";
		$response .= "</MNT_ATTRIBUTES>\n";
	}
	$response .= "</MNT_RESPONSE>\n";
	if ($echo === true)
	{
		header("Content-type: application/xml");
		echo $response;
	}
	else
		return $response;
	if ($die === true)
		die;
	return '';
}

global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang, $database, $mosConfig_mailfrom, $mosConfig_fromname;

/*** access Joomla's configuration file ***/
$my_path = dirname(__FILE__);

if (file_exists($my_path . "/../../../configuration.php")) {
	$absolute_path = dirname($my_path . "/../../../configuration.php");
	require_once ($my_path . "/../../../configuration.php");
} elseif (file_exists($my_path . "/../../configuration.php")) {
	$absolute_path = dirname($my_path . "/../../configuration.php");
	require_once ($my_path . "/../../configuration.php");
} elseif (file_exists($my_path . "/configuration.php")) {
	$absolute_path = dirname($my_path . "/configuration.php");
	require_once ($my_path . "/configuration.php");
} else {
	die("Joomla Configuration File not found!");
}

$absolute_path = realpath($absolute_path);

// Set up the appropriate CMS framework
if (class_exists('jconfig')) {
	define('_JEXEC', 1);
	define('JPATH_BASE', $absolute_path);
	define('DS', DIRECTORY_SEPARATOR);
	
	// Load the framework
	require_once (JPATH_BASE . DS . 'includes' . DS . 'defines.php');
	require_once (JPATH_BASE . DS . 'includes' . DS . 'framework.php');
	
	// create the mainframe object
	$mainframe = & JFactory::getApplication('site');
	
	// Initialize the framework
	$mainframe->initialise();
	
	// load system plugin group
	JPluginHelper::importPlugin('system');
	
	// trigger the onBeforeStart events
	$mainframe->triggerEvent('onBeforeStart');
	$lang = & JFactory::getLanguage();
	$mosConfig_lang = $GLOBALS['mosConfig_lang'] = strtolower($lang->getBackwardLang());
	// Adjust the live site path
	$mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
	$mosConfig_absolute_path = JPATH_BASE;
} else {
	define('_VALID_MOS', '1');
	require_once ($mosConfig_absolute_path . '/includes/joomla.php');
	require_once ($mosConfig_absolute_path . '/includes/database.php');
	$database = new database($mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix);
	$mainframe = new mosMainFrame($database, 'com_virtuemart', $mosConfig_absolute_path);
}

// load Joomla Language File
if (file_exists($mosConfig_absolute_path . '/language/' . $mosConfig_lang . '.php')) {
	require_once ($mosConfig_absolute_path . '/language/' . $mosConfig_lang . '.php');
} elseif (file_exists($mosConfig_absolute_path . '/language/english.php')) {
	require_once ($mosConfig_absolute_path . '/language/english.php');
}
/*** END of Joomla config ***/

/*** VirtueMart part ***/
global $database;
require_once ($mosConfig_absolute_path . '/administrator/components/com_virtuemart/virtuemart.cfg.php');
include_once (ADMINPATH . '/compat.joomla1.5.php');
require_once (ADMINPATH . 'global.php');
require_once (CLASSPATH . 'ps_main.php');
require_once (CLASSPATH . 'ps_database.php');
require_once (CLASSPATH . 'ps_order.php');

/* Load the PAYANYWAY Configuration File */
require_once (CLASSPATH . 'payment/ps_payanyway.cfg.php');

/*** END VirtueMart part ***/


if(isset($_REQUEST['MNT_ID']) && isset($_REQUEST['MNT_TRANSACTION_ID']) && isset($_REQUEST['MNT_OPERATION_ID']) && isset($_REQUEST['MNT_AMOUNT'])
	&& isset($_REQUEST['MNT_CURRENCY_CODE']) && isset($_REQUEST['MNT_TEST_MODE']) && isset($_REQUEST['MNT_SIGNATURE']))
{
	//debugMsg($_GET);

	$MNT_ID       		= $_REQUEST["MNT_ID"];
	$MNT_TRANSACTION_ID	= $_REQUEST["MNT_TRANSACTION_ID"];
	$MNT_OPERATION_ID   = $_REQUEST["MNT_OPERATION_ID"];
	$MNT_AMOUNT        	= $_REQUEST["MNT_AMOUNT"];
	$MNT_CURRENCY_CODE	= $_REQUEST["MNT_CURRENCY_CODE"];
	$MNT_TEST_MODE      = $_REQUEST["MNT_TEST_MODE"];
	$MNT_SIGNATURE      = $_REQUEST["MNT_SIGNATURE"];

	//номер заказа
	$order_number = $MNT_TRANSACTION_ID;

	$signature = md5($MNT_ID . $MNT_TRANSACTION_ID . $MNT_OPERATION_ID . $MNT_AMOUNT . $MNT_CURRENCY_CODE . $MNT_TEST_MODE . DATA_INTEGRITY_CODE);

	//получаем данные заказа
	$sql = "SELECT vo.order_id, vo.order_number, vo.user_id, vo.order_total, vo.order_shipping, voui.user_email FROM #__vm_orders AS vo ".
		   "JOIN #__vm_order_user_info AS voui ON voui.order_id = vo.order_id WHERE vo.order_id='{$order_number}'";

	$dbManger = new ps_DB();

	//debugMsg("Sign: ".$signature);

	$dbManger->query($sql);
	$dbManger->next_record();
	$order_total_cost = sprintf("%.2f", $dbManger->f('order_total'));
	$shop_user = $dbManger->f('user_id');
	$order_id = $dbManger->f('order_id');
	$user_email = $dbManger->f('user_email');
	$kassa_delivery = $dbManger->f('order_shipping');

	//debugMsg("Order total: ".$order_total_cost);

	//проверка подписи и проверка цены
	if ($signature == $MNT_SIGNATURE && $order_total_cost == $MNT_AMOUNT) {
		//обновление статуса заказа

		$order['order_id'] = $order_id;
		$order['notify_customer'] = "Y";
		$order['order_total'] = $order_total_cost;
		$order['order_status'] = 'C';
		$ps_order = new ps_order();
		$ps_order->order_status_update($order);

		//debugMsg("SUCCESS");

        //отправка пользователю подтверждения об оплтае
        $mailsubject = "Заказ № ".$order['order_id']." оплачен.";

        $mailbody = "Статус  заказа No. ".$order['order_id']." был изменен.\n\n";
        $mailbody .= "Новый статус:\n\n";
        $mailbody .= "--------------------------------------- \n";
        $mailbody .= "Confirmed\n";
        $mailbody .= "--------------------------------------- \n\n";
        $mailbody .= "Для просмотра информации о заказе, пожалуйста, ";
        $mailbody .= "пройдите по этой ссылке(или скопируйте её в адресную строку Вашего браузер):\n";
        $mailbody .= URL."index.php?option=com_virtuemart&page=account.order_details&order_id=".$order['order_id']."\n";

        vmMail($mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_mailfrom, $mailsubject, $mailbody);

		if (MNT_KASSA == '1')
		{
			$sql = "SELECT order_item_name, product_quantity, product_final_price FROM #__vm_order_item WHERE order_id='{$order_number}'";
			$dbManger->query($sql);
			$items = $dbManger->loadAssocList();

			$inventoryPositions = array();
			foreach ($items as $item)
			{
				$inventoryPositions[] = array(
					'name' => trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars($item['order_item_name']))),
					'price' => $item['product_final_price'],
					'quantity' => $item['product_quantity'],
					'vatTag' => paw_kassa_VATNOVAT
				);
			}
			$kassa_inventory = json_encode($inventoryPositions);
			monetaPayURLResponse($MNT_ID, $MNT_TRANSACTION_ID, DATA_INTEGRITY_CODE, true, false, true, true,
				$kassa_inventory, $user_email, $kassa_delivery);                                                // 200
		}

		die("SUCCESS");

	} else {
		die("FAIL");
	}
} else {
	die("FAIL");
}

function debugMsg($msg) {	
	// logging
	$fp = fopen('./payanyway.log', 'a+');
	$str = date('Y-m-d H:i:s') . ' - ';
	
	fwrite($fp, $str . "\n" . print_r($msg, true). "\n\n");
	fclose($fp); 
}

?>
